#!/bin/bash
# $Id: qmail-genrsacert.sh,v 1.5 2008/05/19 20:35:46 glen Exp $
# Robin H. Johnson <robbat2@gentoo.org> - October 17, 2003
# This file generates the static temporary RSA keys needed for qmail to encrypt messages
# It should be run from a crontab, once a day is ok on low load machines, but
# if you do lots of mail, once per hour is more reasonable
# if you do NOT create the rsa512.pem, qmail will generate it on the fly for
# each connection, which can be VERY slow.
#
# Revisited by Elan Ruusame <glen@delfi.ee>, 2005-02-25

# we need to make sure that all of the operations succeed
set -e

confdir=/etc/qmail/control
pemfile=$confdir/rsa512.pem
tmpfile=$(mktemp $confdir/rsa512.pem.XXXXXX)

# this is the number of bits in the key
# it should be a power of 2 ideally
# and it must be more than 64!
bits=512

uid="qmaild"
gid="qmail"

/usr/bin/openssl genrsa -out $tmpfile $bits 2>/dev/null
/bin/chown ${uid}:${gid} $tmpfile
# the key should be 0600
# which is readable by qmaild only!
/bin/chmod 600 $tmpfile
/bin/mv -f $tmpfile $pemfile
